
echo ""
echo "         cuteps.sh  /  ncl-metno 1.2"
#echo "          Date:     5 April, 2006"
#echo "          Contact:  a.melsom@met.no"
echo ""


# Check syntax, provide user info.:

if [ "$1" = "--help" ] || [ "$1" = "help" ] || [ "$1" = "-h" ] || [ "$1" = "h" ]
then

 echo ">>> "
 echo ">>> "
 echo ">>> cuteps.sh will:"
 echo ">>>  * cut a rectangle from an eps image"
 echo ">>>  * store the result as a pnm file"
 echo ">>>  * convert the pnm file to png"
 echo ">>>  * delete the pnm file"
 echo ">>> "
 echo ">>> "
 echo ">>> Syntax:"
 echo ">>> ======="
 echo ">>> "
 echo ">>>  cuteps.sh <file root> <left> <top> <width> <heigth>"
 echo ">>> where"
 echo ">>>   <file root>       is the file root, i.e. the file name without the suffix"
 echo ">>>                      (if 'depth.eps' is to be cut, the file root is 'depth')"
 echo ">>>   <left>/<top>      are the left/top pixel no. in the rectancgle to extract"
 echo ">>>                      (the x-direction is positive left-to-right,"
 echo ">>>                       the y-direction is positive top-to-bottom)"
 echo ">>>   <width>/<height>  are the width/height, in #pixels, of the rectancgle to extract"
 echo ">>> "
 echo ">>> "
 echo ">>> Example:"
 echo ">>> ========"
 echo ">>> "
 echo ">>>  cuteps.sh depth 50 220 475 325"
 echo ">>> "
 echo ">>> "
 echo ">>> Terminating."
 echo ""

 exit
fi


if [ "$5" = "" ]
then
 echo ">>> "
 echo ">>> "
 echo ">>> Syntax:"
 echo ">>> ======="
 echo ">>> "
 echo ">>>  cuteps.sh <file root> <left> <top> <width> <heigth>"
 echo ">>> where"
 echo ">>>   <file root>       is the file root, i.e. the file name without the suffix"
 echo ">>>   <left>/<top>      are the left/top pixel no. in the rectancgle to extract"
 echo ">>>   <width>/<height>  are the width/height, in #pixels, of the rectancgle to extract"
 echo ">>> e.g."
 echo ">>>  cuteps.sh depth 50 220 475 325"
 echo ">>> "
 echo ">>> Execute"
 echo ">>>   cuteps.sh --help"
 echo ">>>  for more details, and an example."
 echo ">>> "
 echo ">>> "
 echo ">>> Terminating."
 echo ""

 exit
fi

fileroot=$1
left=$2
top=$3
width=$4
height=$5

epsfile=$fileroot'.eps'
pnminfile=$fileroot'_in.pnm'
pnmoutfile=$fileroot'_out.pnm'
pngfile=$fileroot'.png'


test -r $epsfile || echo ""
test -r $epsfile || echo "  The input file does not exist: " $epsfile
test -r $epsfile || exit


gsbin=`which gs`
pnmcutbin=`which pnmcut`
convertbin=`which convert`

if [ "$pnmcutbin" = "" ] || [ "$convertbin" = "" ]
then
 echo "Could not find one or both of the programs  pnmcut , convert"
 echo "Terminating."
 echo ""
 exit
fi

$gsbin -sDEVICE=pnm -sOutputFile=$pnminfile  -dNOPAUSE $epsfile  <$ncdir/gsin
$pnmcutbin $left $top $width $height  $pnminfile  >$pnmoutfile
$convertbin $pnmoutfile $pngfile 
/bin/rm $pnminfile $pnmoutfile


exit
